<template>
  <section id="import" class="container mx-auto max-w-4xl text-primary">
    <div class="mb-4 border-b-2 border-secondary">
      <h1 class="text-4xl font-bold mb-2">Import form</h1>
    </div>
    <div>
      <div class="relative h-48 mt-4">
        <p class="font-semibold mb-2">Drop your JSON here:</p>
        <div class="bg-gray-50 h-full rounded-md">
          <input
            type="file"
            class="opacity-50 p-2 w-full h-full"
            placeholder="Drop your JSON here"
            v-on:change="handleFileUpload($event)"
          />
        </div>
      </div>
    </div>
  </section>
</template>
<script>
export default {
  data() {
    return {
      file: null,
      upload: false,
    }
  },
  computed: {
    showJson() {
      return this.file
    },
  },
  methods: {
    handleFileUpload(event) {
      var reader = new FileReader() // File reader to read the file

      // This event listener will happen when the reader has read the file
      const el = this
      reader.addEventListener('load', function () {
        var result = JSON.parse(reader.result) // Parse the result into an object
        el.file = result
        el.upload = true
      })

      reader.readAsText(event.target.files[0]) // Read the uploaded file
    },
  },
  watch: {
    file: {
      handler() {
        if (this.upload) {
          // Save the form to localStorage
          let forms = JSON.parse(localStorage.getItem('forms')) || []

          // Prevent duplicate forms
          forms.filter((item) => item?.id === this.file.id)
            ? (forms = forms.filter((item) => item?.id !== this.file.id))
            : (forms = [...forms, this.file])

          forms.push(this.file)
          localStorage.setItem('forms', JSON.stringify(forms))

          // Redirect to the form
          this.$router.push('/form/' + this.file.id)
        }
      },
      deep: true,
    },
  },
}
</script>
